<script>
import {useStore} from "vuex";
import {HOST_API} from "@/vars";
import EventBus from "@/utils/event-bus";

export default {
  name: 'MenuCategories',
  setup() {
    const store = useStore()
    return {
      store,
    }
  },
  data: () => ({
    role: null,
    total: null,
    roles: ["admin"]
  }),
  async created() {
    await this.getCategories()
  },
  computed: {
    isPermittedAction() {
      if (this.role) {
        return this.roles.includes(this.role)
      }
    },
  },
  mounted() {
    this.role = this.store.state.profile.role;

    const instance = this;
    EventBus.on('updated-categories', function (data) {
      if (data) {
        instance.getCategories()
      }
    })
  },
  methods: {

    async getCategories() {

      const response = await fetch(HOST_API + `/categories/`, {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.store.state.categories = await response.json()

      this.total = this.store.state.categories.length

      EventBus.emit('updated-list-categories', true)
    }
  }
}
</script>

<template>
  <div class="col-12 lg:col-12 xl:col-12 mb-0 pb-0" style="position: relative;">
    <h5 class="mb-0">Categorías</h5>
    <router-link v-if="isPermittedAction"
                 :to="{name: 'category_create'}"
                 class="p-button p-component p-button-outlined p-button-secondary mr-2 mb-2"
                 style="position: absolute; right: 10px; top: 10px"
    >
      Crear categoria
    </router-link>
  </div>
  <div class="col-12 lg:col-6 xl:col-4">
    <div class="card mb-0">
      <div class="flex justify-content-between mb-3">
        <div>
          <span class="block text-500 font-medium mb-3">Categorías de proyectos</span>
          <div class="text-900 font-medium text-xl">{{total}}</div>
        </div>
        <div class="flex align-items-center justify-content-center bg-blue-100 border-round" style="width: 2.5rem; height: 2.5rem">
          <i class="pi pi-book text-blue-500 text-xl"></i>
        </div>
      </div>
      <router-link :to="{ name: 'categories_list'}" class="text-green-500 font-medium">
        Ver
      </router-link>
    </div>
  </div>
</template>

<style lang="scss" scoped></style>